Index: pjproject/branches/projects/uwp/pjsip/src/pjsua-lib/pjsua_call.c
===================================================================
--- pjproject/branches/projects/uwp/pjsip/src/pjsua-lib/pjsua_call.c	(revision 5512)
+++ pjproject/branches/projects/uwp/pjsip/src/pjsua-lib/pjsua_call.c	(revision 5513)
@@ -570,5 +570,6 @@
 {
     opt->flag &= ~(PJSUA_CALL_UNHOLD | PJSUA_CALL_UPDATE_CONTACT |
-		   PJSUA_CALL_NO_SDP_OFFER);
+		   PJSUA_CALL_NO_SDP_OFFER | PJSUA_CALL_REINIT_MEDIA |
+		   PJSUA_CALL_UPDATE_VIA);
 }
 
@@ -609,4 +610,8 @@
     call->opt = *opt;
 
+    if (call->opt.flag & PJSUA_CALL_REINIT_MEDIA) {
+    	pjsua_media_channel_deinit(call->index);
+    }
+
     /* If call is established or media channel hasn't been initialized,
      * reinit media channel.
@@ -614,5 +619,6 @@
     if ((call->inv && call->inv->state == PJSIP_INV_STATE_CONNECTING &&
          call->med_cnt == 0) ||
-        (call->inv && call->inv->state == PJSIP_INV_STATE_CONFIRMED))
+        (call->inv && call->inv->state == PJSIP_INV_STATE_CONFIRMED) ||
+        (call->opt.flag & PJSUA_CALL_REINIT_MEDIA))
     {
 	pjsip_role_e role = rem_sdp? PJSIP_ROLE_UAS : PJSIP_ROLE_UAC;
@@ -632,4 +638,25 @@
 
     return PJ_SUCCESS;
+}
+
+static void dlg_set_via(pjsip_dialog *dlg, pjsua_acc *acc)
+{
+    if (acc->cfg.allow_via_rewrite && acc->via_addr.host.slen > 0) {
+        pjsip_dlg_set_via_sent_by(dlg, &acc->via_addr, acc->via_tp);
+    } else if (!pjsua_sip_acc_is_using_stun(acc->index)) {
+   	/* Choose local interface to use in Via if acc is not using
+   	 * STUN. See https://trac.pjsip.org/repos/ticket/1804
+   	 */
+   	pjsip_host_port via_addr;
+   	const void *via_tp;
+
+   	if (pjsua_acc_get_uac_addr(acc->index, dlg->pool, &acc->cfg.id,
+   				   &via_addr, NULL, NULL,
+   				   &via_tp) == PJ_SUCCESS)
+   	{
+   	    pjsip_dlg_set_via_sent_by(dlg, &via_addr,
+   	                              (pjsip_transport*)via_tp);
+   	}
+    }
 }
 
@@ -773,21 +800,5 @@
     pjsip_dlg_inc_lock(dlg);
 
-    if (acc->cfg.allow_via_rewrite && acc->via_addr.host.slen > 0) {
-        pjsip_dlg_set_via_sent_by(dlg, &acc->via_addr, acc->via_tp);
-    } else if (!pjsua_sip_acc_is_using_stun(acc_id)) {
-   	/* Choose local interface to use in Via if acc is not using
-   	 * STUN. See https://trac.pjsip.org/repos/ticket/1804
-   	 */
-   	pjsip_host_port via_addr;
-   	const void *via_tp;
-
-   	if (pjsua_acc_get_uac_addr(acc_id, dlg->pool, &acc->cfg.id,
-   				   &via_addr, NULL, NULL,
-   				   &via_tp) == PJ_SUCCESS)
-   	{
-   	    pjsip_dlg_set_via_sent_by(dlg, &via_addr,
-   	                              (pjsip_transport*)via_tp);
-   	}
-    }
+    dlg_set_via(dlg, acc);
 
     /* Calculate call's secure level */
@@ -954,4 +965,8 @@
     struct call_answer *answer, *next;
 
+    /* No initial answer yet, this function should be called again later */
+    if (!call->inv->last_answer)
+	return;
+
     answer = call->async_call.call_var.inc_call.answers.next;
     while (answer != &call->async_call.call_var.inc_call.answers) {
@@ -983,8 +998,17 @@
     pjsip_tx_data *response = NULL;
     unsigned options = 0;
+    pjsip_dialog *dlg = call->async_call.dlg;
     int sip_err_code = (info? info->sip_err_code: 0);
     pj_status_t status = (info? info->status: PJ_SUCCESS);
 
     PJSUA_LOCK();
+    
+    /* Increment the dialog's lock to prevent it to be destroyed prematurely,
+     * such as in case of transport error.
+     */
+    pjsip_dlg_inc_lock(dlg);
+
+    /* Decrement dialog session. */
+    pjsip_dlg_dec_session(dlg, &pjsua_var.mod);    
 
     if (status != PJ_SUCCESS) {
@@ -997,4 +1021,5 @@
         pjsua_media_channel_deinit(call->index);
         call->med_ch_cb = NULL;
+        pjsip_dlg_dec_lock(dlg);
         PJSUA_UNLOCK();
         return PJ_SUCCESS;
@@ -1068,5 +1093,7 @@
 	}
     }
-
+    
+    pjsip_dlg_dec_lock(dlg);
+    
     PJSUA_UNLOCK();
     return status;
@@ -1089,5 +1116,5 @@
     pjsip_inv_session *inv = NULL;
     int acc_id;
-    pjsua_call *call;
+    pjsua_call *call = NULL;
     int call_id = -1;
     int sip_err_code = PJSIP_SC_INTERNAL_SERVER_ERROR;
@@ -1210,4 +1237,9 @@
 	    goto on_return;
 	}
+    }
+
+    if (!replaced_dlg) {
+	/* Clone rdata. */
+	pjsip_rx_data_clone(rdata, 0, &call->incoming_data);
     }
 
@@ -1352,6 +1384,6 @@
 
     /* Create dialog: */
-    status = pjsip_dlg_create_uas( pjsip_ua_instance(), rdata,
-				   &contact, &dlg);
+    status = pjsip_dlg_create_uas_and_inc_lock( pjsip_ua_instance(), rdata,
+				   		&contact, &dlg);
     if (status != PJ_SUCCESS) {
 	pjsip_endpt_respond_stateless(pjsua_var.endpt, rdata, 500, NULL,
@@ -1460,4 +1492,6 @@
     call->async_call.dlg = dlg;
     pj_list_init(&call->async_call.call_var.inc_call.answers);
+
+    pjsip_dlg_inc_session(dlg, &pjsua_var.mod);
 
     /* Init media channel, only when there is offer or call replace request.
@@ -1502,4 +1536,6 @@
 	    pjsip_dlg_dec_lock(dlg);
 
+	    pjsip_dlg_dec_session(dlg, &pjsua_var.mod);
+
 	    call->inv = NULL;
 	    call->async_call.dlg = NULL;
@@ -1610,4 +1646,17 @@
 	if (pjsua_var.ua_cfg.cb.on_incoming_call) {
 	    pjsua_var.ua_cfg.cb.on_incoming_call(acc_id, call_id, rdata);
+
+	    /* onIncomingCall() may be simulated by onCreateMediaTransport()
+	     * when media init is done synchrounously (see #1916). And if app
+	     * happens to answer/hangup the call from the callback, the 
+	     * answer/hangup should have been delayed (see #1923), 
+	     * so let's process the answer/hangup now.
+	     */
+	    if (call->async_call.call_var.inc_call.hangup) {
+		pjsua_call_hangup(call_id, call->last_code, &call->last_text,
+				  NULL);
+	    } else if (call->med_ch_cb == NULL && call->inv) {
+		process_pending_call_answer(call);
+	    }
 	} else {
 	    pjsua_call_hangup(call_id, PJSIP_SC_TEMPORARILY_UNAVAILABLE,
@@ -1619,4 +1668,13 @@
     /* This INVITE request has been handled. */
 on_return:
+    if (dlg) {
+        pjsip_dlg_dec_lock(dlg);
+    }
+
+    if (call && call->incoming_data) {
+	pjsip_rx_data_free_cloned(call->incoming_data);
+	call->incoming_data = NULL;
+    }
+    
     pj_log_pop_indent();
     PJSUA_UNLOCK();
@@ -2189,6 +2247,8 @@
     /* If media transport creation is not yet completed, we will answer
      * the call in the media transport creation callback instead.
+     * Or if initial answer is not sent yet, we will answer the call after
+     * initial answer is sent (see #1923).
      */
-    if (call->med_ch_cb) {
+    if (call->med_ch_cb || !call->inv->last_answer) {
         struct call_answer *answer;
 
@@ -2204,4 +2264,5 @@
 	}
         if (reason) {
+	    answer->reason = PJ_POOL_ZALLOC_T(call->inv->pool_prov, pj_str_t);
             pj_strdup(call->inv->pool_prov, answer->reason, reason);
         }
@@ -2292,8 +2353,15 @@
      * the call in the media transport creation callback instead.
      */
-    if (call->med_ch_cb && !call->inv) {
+    if ((call->med_ch_cb && !call->inv) ||
+	((call->inv != NULL) && (call->inv->state == PJSIP_INV_STATE_NULL)))
+    {
         PJ_LOG(4,(THIS_FILE, "Pending call %d hangup upon completion "
                              "of media transport", call_id));
-        call->async_call.call_var.out_call.hangup = PJ_TRUE;
+
+	if (call->inv->role == PJSIP_ROLE_UAS)
+	    call->async_call.call_var.inc_call.hangup = PJ_TRUE;
+	else
+	    call->async_call.call_var.out_call.hangup = PJ_TRUE;
+
         if (code == 0)
             call->last_code = PJSIP_SC_REQUEST_TERMINATED;
@@ -2438,4 +2506,10 @@
     }
 
+    if ((options & PJSUA_CALL_UPDATE_VIA) &&
+	pjsua_acc_is_valid(call->acc_id))
+    {
+    	dlg_set_via(call->inv->dlg, &pjsua_var.acc[call->acc_id]);
+    }
+
     /* Create re-INVITE with new offer */
     status = pjsip_inv_reinvite( call->inv, new_contact, sdp, &tdata);
@@ -2559,4 +2633,10 @@
     }
 
+    if ((call->opt.flag & PJSUA_CALL_UPDATE_VIA) &&
+	pjsua_acc_is_valid(call->acc_id))
+    {
+    	dlg_set_via(call->inv->dlg, &pjsua_var.acc[call->acc_id]);
+    }
+
     /* Create re-INVITE with new offer */
     status = pjsip_inv_reinvite( call->inv, new_contact, sdp, &tdata);
@@ -2668,4 +2748,10 @@
     }
 
+    if ((call->opt.flag & PJSUA_CALL_UPDATE_VIA) &&
+	pjsua_acc_is_valid(call->acc_id))
+    {
+	dlg_set_via(call->inv->dlg, &pjsua_var.acc[call->acc_id]);
+    }
+
     /* Create UPDATE with new offer */
     status = pjsip_inv_update(call->inv, new_contact, sdp, &tdata);
@@ -2784,6 +2870,9 @@
     pj_str_t str_dest;
     int len;
+    char call_id_dest_buf[PJSIP_MAX_URL_SIZE * 2];
+    int call_id_len;
     pjsip_uri *uri;
     pj_status_t status;
+    const pjsip_parser_const_t *pconst;
 
 
@@ -2830,5 +2919,20 @@
 
     str_dest.slen += len;
-
+	
+    /* This uses the the same scanner definition used for SIP parsing 
+     * to escape the call-id in the refer.
+     *
+     * A common pattern for call-ids is: name@domain. The '@' character, 
+     * when used in a URL parameter, throws off many SIP parsers. 
+     * URL escape it based off of the allowed characters for header values.
+    */
+    pconst = pjsip_parser_const();	
+    call_id_len = pj_strncpy2_escape(call_id_dest_buf, &dest_dlg->call_id->id,
+     				     PJ_ARRAY_SIZE(call_id_dest_buf),
+     				     &pconst->pjsip_HDR_CHAR_SPEC);
+    if (call_id_len < 0) {
+    	status = PJSIP_EURITOOLONG;
+    	goto on_error;
+    }
 
     /* Build the URI */
@@ -2841,6 +2945,6 @@
 			   ((options&PJSUA_XFER_NO_REQUIRE_REPLACES) ?
 			    "" : "Require=replaces&"),
-			   (int)dest_dlg->call_id->id.slen,
-			   dest_dlg->call_id->id.ptr,
+			   call_id_len,
+			   call_id_dest_buf,
 			   (int)dest_dlg->remote.info->tag.slen,
 			   dest_dlg->remote.info->tag.ptr,
@@ -4050,11 +4154,11 @@
     }
 
+    cleanup_call_setting_flag(&call->opt);
+
     if (pjsua_var.ua_cfg.cb.on_call_rx_offer) {
 	pjsip_status_code code = PJSIP_SC_OK;
 	pjsua_call_setting opt;
 
-	cleanup_call_setting_flag(&call->opt);
 	opt = call->opt;
-
 	(*pjsua_var.ua_cfg.cb.on_call_rx_offer)(call->index, offer, NULL,
 						&code, &opt);
@@ -4182,6 +4286,7 @@
 #endif
 
+    cleanup_call_setting_flag(&call->opt);
+
     if (pjsua_var.ua_cfg.cb.on_call_tx_offer) {
-	cleanup_call_setting_flag(&call->opt);
 	(*pjsua_var.ua_cfg.cb.on_call_tx_offer)(call->index, NULL,
 						&call->opt);
@@ -4471,5 +4576,5 @@
 
     if (refer_sub) {
-	if (!pj_strnicmp2(&refer_sub->hvalue, "true", 4)==0)
+	if (pj_strnicmp2(&refer_sub->hvalue, "true", 4)!=0)
 	    no_refer_sub = PJ_TRUE;
     }
@@ -4777,5 +4882,6 @@
                tsx->state >= PJSIP_TSX_STATE_COMPLETED &&
 	       e->body.tsx_state.prev_state < PJSIP_TSX_STATE_COMPLETED &&
-               (tsx->status_code!=401 && tsx->status_code!=407 &&
+               (!PJSIP_IS_STATUS_IN_CLASS(tsx->status_code, 300) &&
+                tsx->status_code!=401 && tsx->status_code!=407 &&
                 tsx->status_code!=422))
     {
@@ -4822,5 +4928,6 @@
                tsx->state >= PJSIP_TSX_STATE_COMPLETED &&
 	       e->body.tsx_state.prev_state < PJSIP_TSX_STATE_COMPLETED &&
-               (tsx->status_code!=401 && tsx->status_code!=407 &&
+               (!PJSIP_IS_STATUS_IN_CLASS(tsx->status_code, 300) &&
+                tsx->status_code!=401 && tsx->status_code!=407 &&
                 tsx->status_code!=422))
     {
Index: pjproject/branches/projects/uwp/pjsip/src/pjsua-lib/pjsua_core.c
===================================================================
--- pjproject/branches/projects/uwp/pjsip/src/pjsua-lib/pjsua_core.c	(revision 5512)
+++ pjproject/branches/projects/uwp/pjsip/src/pjsua-lib/pjsua_core.c	(revision 5513)
@@ -278,4 +278,5 @@
 #if PJMEDIA_HAS_VIDEO
     pjmedia_vid_stream_rc_config_default(&cfg->vid_stream_rc_cfg);
+    pjmedia_vid_stream_sk_config_default(&cfg->vid_stream_sk_cfg);
 #endif
     pjsua_transport_config_default(&cfg->rtp_cfg);
@@ -303,4 +304,6 @@
     cfg->register_on_acc_add = PJ_TRUE;
     cfg->mwi_expires = PJSIP_MWI_DEFAULT_EXPIRES;
+
+    cfg->media_stun_use = PJSUA_STUN_RETRY_ON_FAILURE;
 }
 
@@ -1050,5 +1053,5 @@
 
     /* Start resolving STUN server */
-    status = resolve_stun_server(PJ_FALSE);
+    status = resolve_stun_server(PJ_FALSE, PJ_FALSE);
     if (status != PJ_SUCCESS && status != PJ_EPENDING) {
 	pjsua_perror(THIS_FILE, "Error resolving STUN server", status);
@@ -1106,5 +1109,7 @@
 
 	for (ii=0; ii<pjsua_var.ua_cfg.thread_cnt; ++ii) {
-	    status = pj_thread_create(pjsua_var.pool, "pjsua", &worker_thread,
+	    char thread_name[16];
+	    pj_ansi_snprintf(thread_name, 16, "pjsua_%d", ii);
+	    status = pj_thread_create(pjsua_var.pool, thread_name, &worker_thread,
 				      NULL, 0, 0, &pjsua_var.thread[ii]);
 	    if (status != PJ_SUCCESS)
@@ -1155,11 +1160,38 @@
 }
 
+
+static void destroy_stun_resolve_cb(pj_timer_heap_t *t, pj_timer_entry *e)
+{
+    pjsua_stun_resolve *sess = (pjsua_stun_resolve*)e->user_data;
+    PJ_UNUSED_ARG(t);
+
+    PJSUA_LOCK();
+    pj_list_erase(sess);
+    PJSUA_UNLOCK();
+
+    pj_assert(sess->stun_sock==NULL);
+    pj_pool_release(sess->pool);
+}
+
+
 static void destroy_stun_resolve(pjsua_stun_resolve *sess)
 {
+    pj_time_val timeout = {0, 0};
+
     sess->destroy_flag = PJ_TRUE;
-    if (sess->ref_cnt > 0)
+
+    /* If the STUN resolution session is blocking, only the waiting thread
+     * is allowed to destroy the session, otherwise it may cause deadlock.
+     */
+    if (sess->blocking) {
+	if (sess->waiter != pj_thread_this())
+	    return;
+
+	/* Before destroying, make sure ref count is zero. */
+	while (sess->ref_cnt > 0)
+	    pj_thread_sleep(10);
+
+    } else if (sess->ref_cnt > 0)
 	return;
-
-    PJSUA_LOCK();
 
     if (sess->stun_sock) {
@@ -1174,10 +1206,12 @@
     }
     
-    pj_list_erase(sess);
-
-    PJSUA_UNLOCK();
-
-    pj_assert(sess->stun_sock==NULL);
-    pj_pool_release(sess->pool);
+    /* Schedule session clean up, it needs PJSUA lock and locking it here
+     * may cause deadlock as this function may be called by STUN socket
+     * while holding STUN socket lock, while application may wait for STUN
+     * resolution while holding PJSUA lock.
+     */
+    pj_timer_entry_init(&sess->timer, 0, (void*)sess,
+			&destroy_stun_resolve_cb);
+    pjsua_schedule_timer(&sess->timer, &timeout);
 }
 
@@ -1204,4 +1238,5 @@
     result.status = sess->status;
     result.name = sess->srv[sess->idx];
+    result.index = sess->idx;
     pj_memcpy(&result.addr, &sess->addr, sizeof(result.addr));
     sess->has_result = PJ_TRUE;
@@ -1221,7 +1256,5 @@
     }
 
-    stun_resolve_add_ref(sess);
     sess->cb(&result);
-    stun_resolve_dec_ref(sess);
 
 on_return:
@@ -1252,6 +1285,16 @@
 		  sess->srv[sess->idx].ptr, errmsg));
 
+	if (op == PJ_STUN_SOCK_BINDING_OP && !sess->async_wait) {
+	    /* Just return here, we will destroy the STUN socket and
+	     * continue the STUN resolution later in resolve_stun_entry().
+	     * For more details, please refer to ticket #1962.
+	     */
+            return PJ_FALSE;
+	}
+
 	pj_stun_sock_destroy(stun_sock);
 	sess->stun_sock = NULL;
+
+	stun_resolve_add_ref(sess);
 
 	++sess->idx;
@@ -1261,4 +1304,6 @@
 	resolve_stun_entry(sess);
 
+	stun_resolve_dec_ref(sess);
+
 	return PJ_FALSE;
 
@@ -1268,4 +1313,6 @@
 	pj_stun_sock_get_info(stun_sock, &ssi);
 	pj_memcpy(&sess->addr, &ssi.srv_addr, sizeof(sess->addr));
+
+	stun_resolve_add_ref(sess);
 
 	sess->status = PJ_SUCCESS;
@@ -1275,4 +1322,6 @@
 	stun_resolve_complete(sess);
 
+	stun_resolve_dec_ref(sess);
+
 	return PJ_FALSE;
 
@@ -1290,9 +1339,7 @@
     pj_status_t status = PJ_EUNKNOWN;
 
-    stun_resolve_add_ref(sess);
-
     /* Loop while we have entry to try */
     for (; sess->idx < sess->count; ++sess->idx) {
-	const int af = pj_AF_INET();
+	int af;
 	char target[64];
 	pj_str_t hostpart;
@@ -1307,8 +1354,16 @@
 
 	/* Parse the server entry into host:port */
-	status = pj_sockaddr_parse2(af, 0, &sess->srv[sess->idx],
-					  &hostpart, &port, NULL);
+	status = pj_sockaddr_parse2(pj_AF_UNSPEC(), 0, &sess->srv[sess->idx],
+				    &hostpart, &port, &af);
 	if (status != PJ_SUCCESS) {
     	    PJ_LOG(2,(THIS_FILE, "Invalid STUN server entry %s", target));
+	    continue;
+	} else if (af != pj_AF_INET()) {
+	    /* Ignore IPv6 STUN server for now */
+	    status = PJ_EAFNOTSUP;
+	    PJ_LOG(3,(THIS_FILE, "Ignored STUN server entry %s, currently "
+				 "only IPv4 STUN server is supported (does "
+				 "IPv6 still need a mapped address?)",
+		      target));
 	    continue;
 	}
@@ -1326,7 +1381,8 @@
 	pj_bzero(&stun_sock_cb, sizeof(stun_sock_cb));
 	stun_sock_cb.on_status = &test_stun_on_status;
+	sess->async_wait = PJ_FALSE;
 	status = pj_stun_sock_create(&pjsua_var.stun_cfg, "stunresolve",
-					   pj_AF_INET(), &stun_sock_cb,
-					   NULL, sess, &sess->stun_sock);
+				     pj_AF_INET(), &stun_sock_cb,
+				     NULL, sess, &sess->stun_sock);
 	if (status != PJ_SUCCESS) {
 	    char errmsg[PJ_ERR_MSG_SIZE];
@@ -1339,6 +1395,6 @@
 	}
 
-	status = pj_stun_sock_start(sess->stun_sock, &hostpart,
-					  port, pjsua_var.resolver);
+	status = pj_stun_sock_start(sess->stun_sock, &hostpart, port,
+				    pjsua_var.resolver);
 	if (status != PJ_SUCCESS) {
 	    char errmsg[PJ_ERR_MSG_SIZE];
@@ -1358,17 +1414,47 @@
 	 * stun_sock_cb()
 	 */
-	goto on_return;
+	sess->async_wait = PJ_TRUE;
+	return;
     }
 
     if (sess->idx >= sess->count) {
 	/* No more entries to try */
+	stun_resolve_add_ref(sess);
 	pj_assert(status != PJ_SUCCESS || sess->status != PJ_EPENDING);
         if (sess->status == PJ_EPENDING)
             sess->status = status;
 	stun_resolve_complete(sess);
-    }
-
-on_return:
-    stun_resolve_dec_ref(sess);
+	stun_resolve_dec_ref(sess);
+    }
+}
+
+
+/*
+ * Update STUN servers.
+ */
+PJ_DEF(pj_status_t) pjsua_update_stun_servers(unsigned count, pj_str_t srv[],
+					      pj_bool_t wait)
+{
+    unsigned i;
+    pj_status_t status;
+
+    PJ_ASSERT_RETURN(count && srv, PJ_EINVAL);
+    
+    PJSUA_LOCK();
+
+    pjsua_var.ua_cfg.stun_srv_cnt = count;
+    for (i = 0; i < count; i++) {
+        if (pj_strcmp(&pjsua_var.ua_cfg.stun_srv[i], &srv[i]))
+            pj_strdup(pjsua_var.pool, &pjsua_var.ua_cfg.stun_srv[i], &srv[i]);
+    }
+    pjsua_var.stun_status = PJ_EUNKNOWN;
+
+    PJSUA_UNLOCK();
+    
+    status = resolve_stun_server(wait, PJ_FALSE);
+    if (wait == PJ_FALSE && status == PJ_EPENDING)
+        status = PJ_SUCCESS;
+
+    return status;
 }
 
@@ -1386,5 +1472,6 @@
     pjsua_stun_resolve *sess;
     pj_status_t status;
-    unsigned i;
+    unsigned i, max_wait_ms;
+    pj_timestamp start, now;
 
     PJ_ASSERT_RETURN(count && srv && cb, PJ_EINVAL);
@@ -1400,4 +1487,5 @@
     sess->count = count;
     sess->blocking = wait;
+    sess->waiter = pj_thread_this();
     sess->status = PJ_EPENDING;
     sess->srv = (pj_str_t*) pj_pool_calloc(pool, count, sizeof(pj_str_t));
@@ -1414,4 +1502,11 @@
     if (!wait)
 	return PJ_SUCCESS;
+
+    /* Should limit the wait time to avoid deadlock. For example,
+     * if app holds dlg/tsx lock, pjsua worker thread will block on
+     * any dlg/tsx state change.
+     */
+    max_wait_ms = count * pjsua_var.stun_cfg.rto_msec * (1 << 7);
+    pj_get_timestamp(&start);
 
     while (sess->status == PJ_EPENDING) {
@@ -1428,4 +1523,8 @@
             pj_thread_sleep(20);
         }
+
+	pj_get_timestamp(&now);
+	if (pj_elapsed_msec(&start, &now) > max_wait_ms)
+	    sess->status = PJ_ETIMEDOUT;
     }
 
@@ -1477,7 +1576,9 @@
     if ((result->status == PJ_SUCCESS) && (pjsua_var.ua_cfg.stun_srv_cnt>0)) {
 	pj_memcpy(&pjsua_var.stun_srv, &result->addr, sizeof(result->addr));
+	pjsua_var.stun_srv_idx = result->index;
 
 	/* Perform NAT type detection if not yet */
 	if (pjsua_var.nat_type == PJ_STUN_NAT_TYPE_UNKNOWN &&
+	    !pjsua_var.nat_in_progress &&
 	    pjsua_var.ua_cfg.nat_type_in_sdp)
 	{
@@ -1493,6 +1594,14 @@
  * Resolve STUN server.
  */
-pj_status_t resolve_stun_server(pj_bool_t wait)
-{
+pj_status_t resolve_stun_server(pj_bool_t wait, pj_bool_t retry_if_cur_error)
+{
+    /* Retry resolving if currently the STUN status is error */
+    if (pjsua_var.stun_status != PJ_EPENDING &&
+	pjsua_var.stun_status != PJ_SUCCESS &&
+	retry_if_cur_error)
+    {
+	pjsua_var.stun_status = PJ_EUNKNOWN;
+    }
+
     if (pjsua_var.stun_status == PJ_EUNKNOWN) {
 	pj_status_t status;
@@ -1522,5 +1631,16 @@
 	 */
 	if (wait) {
-	    while (pjsua_var.stun_status == PJ_EPENDING) {
+	    unsigned max_wait_ms;
+	    pj_timestamp start, now;
+
+	    /* Should limit the wait time to avoid deadlock. For example,
+	     * if app holds dlg/tsx lock, pjsua worker thread will block on
+	     * any dlg/tsx state change.
+	     */
+	    max_wait_ms = pjsua_var.ua_cfg.stun_srv_cnt *
+			  pjsua_var.stun_cfg.rto_msec * (1 << 7);
+	    pj_get_timestamp(&start);
+
+	    while (pjsua_var.stun_status == PJ_EPENDING) {		
                 /* If there is no worker thread or
                  * the function is called from the only worker thread,
@@ -1535,4 +1655,8 @@
 		    pj_thread_sleep(10);
                 }
+
+		pj_get_timestamp(&now);
+		if (pj_elapsed_msec(&start, &now) > max_wait_ms)
+		    return PJ_ETIMEDOUT;
 	    }
 	}
@@ -1545,5 +1669,6 @@
 	PJ_LOG(2,(THIS_FILE, 
 		  "Ignoring STUN resolution failure (by setting)"));
-	pjsua_var.stun_status = PJ_SUCCESS;
+	//pjsua_var.stun_status = PJ_SUCCESS;
+	return PJ_SUCCESS;
     }
 
@@ -1956,5 +2081,5 @@
 
     /* Make sure STUN server resolution has completed */
-    status = resolve_stun_server(PJ_TRUE);
+    status = resolve_stun_server(PJ_TRUE, PJ_TRUE);
     if (status != PJ_SUCCESS) {
 	pjsua_perror(THIS_FILE, "Error resolving STUN server", status);
@@ -2015,5 +2140,6 @@
 
     if (pjsua_var.stun_srv.addr.sa_family != 0) {
-	pj_ansi_strcpy(stun_ip_addr,pj_inet_ntoa(pjsua_var.stun_srv.ipv4.sin_addr));
+    	pj_sockaddr_print(&pjsua_var.stun_srv,
+    		     	  stun_ip_addr, sizeof(stun_ip_addr), 0);
 	stun_srv = pj_str(stun_ip_addr);
     } else {
@@ -2032,16 +2158,11 @@
 	    pj_sockaddr_set_port(p_pub_addr, (pj_uint16_t)port);
 
-    } else if (stun_srv.slen) {
+    } else if (stun_srv.slen && af == pj_AF_INET()) {
 	pjstun_setting stun_opt;
 
 	/*
 	 * STUN is specified, resolve the address with STUN.
+	 * Currently, this is available for IPv4 address only.
 	 */
-	if (af != pj_AF_INET()) {
-	    pjsua_perror(THIS_FILE, "Cannot use STUN", PJ_EAFNOTSUP);
-	    pj_sock_close(sock);
-	    return PJ_EAFNOTSUP;
-	}
-
 	pj_bzero(&stun_opt, sizeof(stun_opt));
 	stun_opt.use_stun2 = pjsua_var.ua_cfg.stun_map_use_stun2;
@@ -2052,10 +2173,25 @@
 					 1, &sock, &p_pub_addr->ipv4);
 	if (status != PJ_SUCCESS) {
+	    /* Failed getting mapped address via STUN */
 	    pjsua_perror(THIS_FILE, "Error contacting STUN server", status);
-	    pj_sock_close(sock);
-	    return status;
+	    
+	    /* Return error if configured to not ignore STUN failure */
+	    if (!pjsua_var.ua_cfg.stun_ignore_failure) {
+		pj_sock_close(sock);
+		return status;
+	    }
+
+	    /* Otherwise, just use host IP */
+	    pj_sockaddr_init(af, p_pub_addr, NULL, (pj_uint16_t)port);
+	    status = pj_gethostip(af, p_pub_addr);
+	    if (status != PJ_SUCCESS) {
+		pjsua_perror(THIS_FILE, "Unable to get local host IP", status);
+		pj_sock_close(sock);
+		return status;
+	    }
 	}
 
     } else {
+
 	pj_bzero(p_pub_addr, sizeof(pj_sockaddr));
 
@@ -2073,4 +2209,13 @@
 	p_pub_addr->addr.sa_family = (pj_uint16_t)af;
 	pj_sockaddr_set_port(p_pub_addr, (pj_uint16_t)port);
+
+	if (stun_srv.slen && af != pj_AF_INET()) {
+	    /* STUN is specified, but it is not IPv4, just print warning */
+	    PJ_PERROR(2, (THIS_FILE, PJ_EAFNOTSUP,
+		          "Cannot use STUN for SIP UDP socket %s:%d",
+		          addr_string(p_pub_addr),
+		          (int)pj_sockaddr_get_port(p_pub_addr)));
+	}
+
     }
 
@@ -2406,5 +2551,5 @@
     PJSUA_LOCK();
 
-    if (t->type == PJSIP_TRANSPORT_UDP) {
+    if ((t->type & ~PJSIP_TRANSPORT_IPV6) == PJSIP_TRANSPORT_UDP) {
 
 	pjsip_transport *tp = t->data.tp;
@@ -2427,6 +2572,6 @@
 	status = PJ_SUCCESS;
 
-    } else if (t->type == PJSIP_TRANSPORT_TCP ||
-	       t->type == PJSIP_TRANSPORT_TLS)
+    } else if ((t->type & ~PJSIP_TRANSPORT_IPV6) == PJSIP_TRANSPORT_TCP ||
+	       (t->type & ~PJSIP_TRANSPORT_IPV6) == PJSIP_TRANSPORT_TLS)
     {
 
@@ -2440,8 +2585,6 @@
 	info->id = id;
 	info->type = t->type;
-	info->type_name = (t->type==PJSIP_TRANSPORT_TCP)? pj_str("TCP"):
-							  pj_str("TLS");
-	info->info = (t->type==PJSIP_TRANSPORT_TCP)? pj_str("TCP transport"):
-						     pj_str("TLS transport");
+	info->type_name = pj_str(factory->type_name);
+	info->info = pj_str(factory->info);
 	info->flag = factory->flag;
 	info->addr_len = sizeof(factory->local_addr);
@@ -2493,4 +2636,5 @@
 {
     pj_status_t status;
+    pjsip_transport_type_e tp_type;
 
     /* Make sure id is in range. */
@@ -2500,4 +2644,6 @@
     /* Make sure that transport exists */
     PJ_ASSERT_RETURN(pjsua_var.tpdata[id].data.ptr != NULL, PJ_EINVAL);
+
+    tp_type = pjsua_var.tpdata[id].type & ~PJSIP_TRANSPORT_IPV6;
 
     /* Note: destroy() may not work if there are objects still referencing
@@ -2505,5 +2651,5 @@
      */
     if (force) {
-	switch (pjsua_var.tpdata[id].type) {
+	switch (tp_type) {
 	case PJSIP_TRANSPORT_UDP:
 	    status = pjsip_transport_shutdown(pjsua_var.tpdata[id].data.tp);
@@ -2538,5 +2684,5 @@
 	 * descriptor.
 	 */
-	switch (pjsua_var.tpdata[id].type) {
+	switch (tp_type) {
 	case PJSIP_TRANSPORT_UDP:
 	    return pjsip_transport_shutdown(pjsua_var.tpdata[id].data.tp);
@@ -2741,5 +2887,5 @@
 
     /* Make sure STUN server resolution has completed */
-    status = resolve_stun_server(PJ_TRUE);
+    status = resolve_stun_server(PJ_TRUE, PJ_TRUE);
     if (status != PJ_SUCCESS) {
 	pjsua_var.nat_status = status;
Index: pjproject/branches/projects/uwp/pjsip/src/pjsua-lib/pjsua_im.c
===================================================================
--- pjproject/branches/projects/uwp/pjsip/src/pjsua-lib/pjsua_im.c	(revision 5512)
+++ pjproject/branches/projects/uwp/pjsip/src/pjsua-lib/pjsua_im.c	(revision 5513)
@@ -388,6 +388,8 @@
 		if (status == PJ_SUCCESS) {
 		    /* Done */
+		    pjsip_auth_clt_deinit(&auth);
 		    return;
 		}
+		pjsip_auth_clt_deinit(&auth);
 	    }
 	}
@@ -490,6 +492,8 @@
 		if (status == PJ_SUCCESS) {
 		    /* Done */
+		    pjsip_auth_clt_deinit(&auth);
 		    return;
 		}
+		pjsip_auth_clt_deinit(&auth);
 	    }
 	}
